--
-- PipeFix
--

PipeFix = {}

function PipeFix.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(Overloading, specializations) and SpecializationUtil.hasSpecialization(Trailer, specializations) and SpecializationUtil.hasSpecialization(Pipe, specializations)
end

function PipeFix:load(savegame)
	self.pipeTextFix = true
	g_i18n.globalI18N.texts["action_pipeTextFix_pipeIn"] = g_i18n:getText("action_pipeTextFix_pipeIn")
	g_i18n.globalI18N.texts["action_pipeTextFix_pipeOut"] = g_i18n:getText("action_pipeTextFix_pipeOut")
	self.getCanTipToGround = PipeFix.getCanTipToGround
end

function PipeFix:getCanTipToGround()
	if TipUtil.isValid() then
		if self.pipeStateIsUnloading[self.pipeCurrentState] then
			local fillType = self:getUnitLastValidFillType(self.overloading.fillUnitIndex)
			if fillType ~= FillUtil.FILLTYPE_UNKNOWN then
				return TipUtil.getCanTipToGround(fillType)
			else
				return true
			end
		else
			local currentFillType = self:getUnitFillType(self.trailer.fillUnitIndex)
			if currentFillType ~= FillUtil.FILLTYPE_UNKNOWN then
				return TipUtil.getCanTipToGround(currentFillType)
			else
				return true
			end
		end
        return false
    else
        return false
    end
end

function PipeFix:delete()
end 

function PipeFix:mouseEvent(posX, posY, isDown, isUp, button)
end

function PipeFix:keyEvent(unicode, sym, modifier, isDown)
end

function PipeFix:update(dt)
end

function PipeFix:draw()
end

local oldPipeDraw = Pipe.draw
Pipe.draw = function(self)
	if self.pipeTextFix then
		if self.isClient and self:getIsActiveForInput(true) and not self:hasInputConflictWithSelection() then
			if self.hasPipe then
				if self.pipeNumStates == 2 then
					if self.pipeTargetState == 2 then
						if self:getIsPipeStateChangeAllowed(1) then
							g_currentMission:addHelpButtonText(g_i18n:getText("action_pipeTextFix_pipeIn"), InputBinding.TOGGLE_PIPE, nil, GS_PRIO_HIGH)
						end
					else
						if self:getIsPipeStateChangeAllowed(2) then
							g_currentMission:addHelpButtonText(g_i18n:getText("action_pipeTextFix_pipeOut"), InputBinding.TOGGLE_PIPE, nil, GS_PRIO_HIGH)
						end
					end
				end
			end
			if not self.pipeFoundTrailer and self:getCanTipToGround() then
				if self.dischargeToGround then
					g_currentMission:addHelpButtonText(g_i18n:getText("action_stopTipToGround"), InputBinding.TOGGLE_TIPSTATE_GROUND, nil, GS_PRIO_HIGH)
				elseif not self.overloading.didOverload then
					g_currentMission:addHelpButtonText(g_i18n:getText("action_startTipToGround"), InputBinding.TOGGLE_TIPSTATE_GROUND, nil, GS_PRIO_HIGH)
				end
			end
		end
	else
		oldPipeDraw(self)
	end
end
